
/** Receives a JSON-converted version of the manifest.xml file, and returns an easier to read JSON file */
export default function parsePatchManifest(manifestFile: any): any {
  const out: any = {};

  const PatchManifest = manifestFile.elements[0];

  //<RequiredRelease>289</RequiredRelease>
  const RequiredRelease = PatchManifest.elements[2];
  out.current = Number(RequiredRelease.elements[0].text);

  //<Releases><Release><Id>0</Id><SHA1>53678f8057e52896a8145dca5c188ab3f24fa55f</SHA1></Release></Releases>
  const Releases = PatchManifest.elements[7];
  out.releases = {};
  Releases.elements.forEach((Release: any) => {
    const id = Release.elements[0].elements[0].text;
    const sha1 = Release.elements[1].elements[0].text;
    out.releases[id] = { sha1, from: [], to: [] };
  });

  const ReleaseUpdatePaths = PatchManifest.elements[8];
  ReleaseUpdatePaths.elements.forEach((ReleaseUpdatePath: any) => {
    const from = ReleaseUpdatePath.elements[0].elements[0].text;
    const to = ReleaseUpdatePath.elements[1].elements[0].text;
    if (from !== '-1') {
      out.releases[from].to.push(to);
    }
    out.releases[to].from.push(from);
  });

  return out;
}
